#ifndef AGTREE_INCLUDED
#define AGTREE_INCLUDED

#define INVCONST 1e-9
#define PINV


struct cmds{
  char trainfile[255];
  char prunefile[255];
  char outfile[255];
  int nb_clusters;
  int nb_nodes;
  int merge_limit;
  double alpha; /* factor weighting distance of cluster means into */
                /* cost funtion for cluster merging. default is 0.0, */
  double avg_cost_md,avg_cost_tot; 

  int prune; /* =1 when pruning is switched on */

};

struct data{
  double **data;
  int x_len, y_len;
  int nb_points;
};


struct node{
  int root_FLAG;
  int parent, child1, child2;
  int nb_points;
  double *mean;
  double **R,**Cyy;
  double **vect;
  double **a;
  double pred_err;

  double *ymean;
  double *xmean;
  double *b;
  double **yer2;

  double subtree_err;
  int prune_FLAG; /* -1=pruning off or not yet performed
                      0=node not pruned, i.e. use this node for the prediction, 
                        don't go up higher in tree to find merged node.
                      1=pruned, at runtime follow this up to merged
                        node (higher in tree) with prune_FLAG=0. Use
                        that node for prediction */
};


void make_agtree(struct cmds *params);

struct node* read_tree(char *fname, int *Xlen, int *Ylen, int *nbclust, int *nbnode); /* implemented in agt_io.c */

int classify_xvec(double *xvec, int x_len, struct node *clust, struct cmds *params); /* implemented in agt_tree.c */






#endif
